/* This Program Calculates Distibution of Distances                  */
/* Created by: Dr. Jeff Klauda                                       */
/* Date: 09/26/2007                                                  */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

FILE *main_inp;
FILE *main_inp2;
FILE *main_out;

int main(void)
{
    char input[80],output[80],output2[80];
    long i,j,ntot,k;
    int status,ND;
    double maxd, mind;

    printf("\n\n# of Distances: ");
    scanf("%d",&ND);

    printf("\n\nMax Distance: ");
    scanf("%lf",&maxd);

    printf("\n\nMin Distance: ");
    scanf("%lf",&mind);

    double t,temp,bin1[1000];

        for(i=0;i<1000;i++)
        {
            bin1[i]=0;
        }

    printf("\n\nDist Data File: ");
    scanf("%s",&input);
    main_inp = fopen (input,"r");

    printf("\n\nDist Distr Output File: ");
    scanf("%s",&output);
    main_out = fopen (output,"w");

// Read in data

    i=-1;
    status = 1;
    while(status != EOF)
    {
        i++;
        status=fscanf(main_inp,"%lf",&t);
        for(j=0;j<ND;j++)
        {
           status=fscanf(main_inp,"%lf",&temp);
// Bin Distances
           for(k=0;k<(maxd-mind)*10;k++)
           {
                   if(temp>=(mind+k*0.1) && temp < (mind+(k+1)*0.1))
                        bin1[k]++;
           }
        }
    }
    fclose(main_inp);
    ntot=(i+1);

// check values of ntot
    printf("\n\nntot is: %d", ntot);

//  Printout results

    for(i=0;i<(maxd-mind)*10;i++)
            bin1[i]=bin1[i]/ntot/ND;      /* Scale by 10 because stepsize is 0.1 */

    fprintf(main_out,"Dist\tProb\n");
    for(i=0;i<(maxd-mind)*10;i++)
    {
        fprintf(main_out,"%1.2lf\t",mind+i/10.0);
        fprintf(main_out,"%1.5E\t",bin1[i]);
        fprintf(main_out,"\n");
    }
     printf("\n");   /* XZ: add this line so that the system start a new line after this script finish the run */
}

